#include "isa-thumb.h"

static const ThumbInstruction _thumbTable[0x400];

// Instruction definitions

#define APPLY(F, ...) F(__VA_ARGS__)
#define DUMMY(...) __VA_ARGS__

#define COUNT_1(EMITTER, PREFIX, ...) \
	EMITTER(PREFIX ## 0, __VA_ARGS__) \
	EMITTER(PREFIX ## 1, __VA_ARGS__)

#define COUNT_2(EMITTER, PREFIX, ...) \
	COUNT_1(EMITTER, PREFIX, __VA_ARGS__) \
	EMITTER(PREFIX ## 2, __VA_ARGS__) \
	EMITTER(PREFIX ## 3, __VA_ARGS__)

#define COUNT_3(EMITTER, PREFIX, ...) \
	COUNT_2(EMITTER, PREFIX, __VA_ARGS__) \
	EMITTER(PREFIX ## 4, __VA_ARGS__) \
	EMITTER(PREFIX ## 5, __VA_ARGS__) \
	EMITTER(PREFIX ## 6, __VA_ARGS__) \
	EMITTER(PREFIX ## 7, __VA_ARGS__)

#define COUNT_4(EMITTER, PREFIX, ...) \
	COUNT_3(EMITTER, PREFIX, __VA_ARGS__) \
	EMITTER(PREFIX ## 8, __VA_ARGS__) \
	EMITTER(PREFIX ## 9, __VA_ARGS__) \
	EMITTER(PREFIX ## A, __VA_ARGS__) \
	EMITTER(PREFIX ## B, __VA_ARGS__) \
	EMITTER(PREFIX ## C, __VA_ARGS__) \
	EMITTER(PREFIX ## D, __VA_ARGS__) \
	EMITTER(PREFIX ## E, __VA_ARGS__) \
	EMITTER(PREFIX ## F, __VA_ARGS__)

#define COUNT_5(EMITTER, PREFIX, ...) \
	COUNT_4(EMITTER, PREFIX ## 0, __VA_ARGS__) \
	COUNT_4(EMITTER, PREFIX ## 1, __VA_ARGS__)

#define THUMB_WRITE_PC \
	cpu->gprs[ARM_PC] = (cpu->gprs[ARM_PC] & -WORD_SIZE_THUMB) + WORD_SIZE_THUMB

#define DEFINE_INSTRUCTION_THUMB(NAME, BODY) \
	static void _ThumbInstruction ## NAME (struct ARMCore* cpu, uint16_t opcode) {  \
		BODY; \
	}

#define DEFINE_SHIFT_INSTRUCTION_THUMB(NAME, BODY) \
	COUNT_5(DEFINE_INSTRUCTION_THUMB, NAME ## _, BODY)

DEFINE_SHIFT_INSTRUCTION_THUMB(LSL, )
DEFINE_SHIFT_INSTRUCTION_THUMB(LSR, )
DEFINE_SHIFT_INSTRUCTION_THUMB(ASR, )

#define DECLARE_INSTRUCTION_THUMB(EMITTER, NAME) \
	EMITTER ## NAME

#define DECLARE_THUMB_EMITTER_BLOCK(EMITTER) \
	APPLY(COUNT_5, DUMMY, DECLARE_INSTRUCTION_THUMB(EMITTER, LSL_)) \
	APPLY(COUNT_5, DUMMY, DECLARE_INSTRUCTION_THUMB(EMITTER, LSR_)) \
	APPLY(COUNT_5, DUMMY, DECLARE_INSTRUCTION_THUMB(EMITTER, ASR_)) \

static const ThumbInstruction _thumbTable[0x400] = {
	DECLARE_THUMB_EMITTER_BLOCK(_ThumbInstruction)
};
